package org.start.command;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import org.start.data.TeamManager;
import org.start.player.cuan_song.chuan_song;
import org.start.player.pCase.pCase_run_;
import org.start.print;
import org.start.player.bossbar.boss_bar_runs;

public class command implements CommandExecutor {


    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {

        Player player = (Player) sender;
        ChatColor r = ChatColor.RED;
        ChatColor g = ChatColor.GREEN;
        ChatColor y = ChatColor.YELLOW;
        ChatColor b = ChatColor.BLUE;

        if (args.length == 0){
            print.player_p(player,"&命令不正确，请使用 /war help 了解更多");
            return false;
        }

        //处理 help 命令
        if (args[0].equalsIgnoreCase("help")){
            player.sendMessage("  ");
            print.player_p(player, "&e=======&b[ &a守塔模式 (内部插件) &b]&e=======");
            player.sendMessage("用法:/war join red 加入进攻方");
            player.sendMessage("    /war join blue 加入防守方");
            player.sendMessage("    /war stop 离开守塔模式");
            return true;
        }

        //处理 join事件
        if (args[0].equalsIgnoreCase("join")) {
            if (args.length < 2){
                print.player_p(player,"你需要指定一个想要加入的队伍&a red:进攻方  blue：防守方");
                return true;
            }

            String joinType = args[1].toLowerCase();
            if (joinType.equals("red")){
                if (TeamManager.isPlayerInTeam(player.getName())){
                    print.player_p(player, "&e警告&f你已加入"+ TeamManager.getPlayer(player.getName())+"，请勿重复加入");
                    return true;
                }else {
                    chuan_song.toRed(player);
                    TeamManager.setPlayer(player.getName(), "red");  //将玩家传入存储类
                    boss_bar_runs.onPlayerJoinTeam(player,"red");  //为玩家添加进度条
                    print.player_p(player,"你已加入进攻方");
                    print.boardChat("玩家"+ player.getName()+"加入进攻方");
                    pCase_run_.joinRed(player);
                    return true;
                }
            }
            if (joinType.equals("blue")){
                if (TeamManager.isPlayerInTeam(player.getName())) {
                    print.player_p(player, "&e警告&f你已加入" + TeamManager.getPlayer(player.getName()) + "，请勿重复加入");
                    return true;
                }else {
                    chuan_song.toBlue(player);
                    TeamManager.setPlayer(player.getName(), "blue");
                    boss_bar_runs.onPlayerJoinTeam(player,"blue");
                    print.player_p(player,"你已加入防守方");
                    print.boardChat("玩家"+ player.getName()+"加入进攻方");
                    pCase_run_.joinBlue(player);
                    return true;
                }

            }else {
                print.player_p(player,"无效队伍，请重试");
                return true;
            }
        }

        //处理 stop 命令
        if (args[0].equalsIgnoreCase("stop")){
            print.player_p(player,"你已离开守塔模式");
            chuan_song.toStop(player);
            boss_bar_runs.onPlayerLeaveTeam(player);  //移除玩家的进度条
            print.boardChat("玩家"+ player.getName()+"离开守塔模式");
            TeamManager.removePlayer(player.getName());  //将玩家移出存储类
            pCase_run_.stop(player);
            return true;
        }

        print.player_p(player,"无效命令，请重试");
        return false;
    }
}
